/*
** 3/06/2001
** http://graphics.stanford.edu/software/wiregl
**
** Copyright 2001
** The Board of Trustees of The Leland Stanford Junior University.
** All rights reserved.
**
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or
** modify this software, provided that the above copyright notice and
** this permission notice appear in all copies of this software.  No
** part of this software or any derivatives thereof may be used in
** graphics systems for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind,
** express, implied or otherwise, including without limitation, any
** warranty of merchantability or fitness for a particular purpose.
*/

#ifdef WINDOWS
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif
#include <GL/gl.h>

#include "wiregl/include/wireGL.h"
#include "wiregl/include/wiregl_protocol.h"
#include "wiregl/include/wiregl_pipe.h"
#include "wiregl/include/wiregl_util.h"
#include "wiregl/glcontext/glcontext.h"

void __decodeMultMatrixd( void  )
{
#ifdef WIREGL_UNALIGNED_ACCESS_OKAY
	GLdouble *m = DATA_POINTER( 0, GLdouble );
#else
	GLdouble m[16];
	memcpy( m, DATA_POINTER( 0, GLdouble ), sizeof(m) );
#endif

	__gltrack_MultMatrixd( m );
	INCR_DATA_PTR( 16*sizeof( GLdouble ) );
}

void __decodeMultMatrixf( void  )
{
	GLfloat *m = DATA_POINTER( 0, GLfloat );

	__gltrack_MultMatrixf( m );
	INCR_DATA_PTR( 16*sizeof( GLfloat ) );
}

void __decodeLoadMatrixd( void  )
{
#ifdef WIREGL_UNALIGNED_ACCESS_OKAY
	GLdouble *m = DATA_POINTER( 0, GLdouble );
#else
	GLdouble m[16];
	memcpy( m, DATA_POINTER( 0, GLdouble ), sizeof(m) );
#endif

	__gltrack_LoadMatrixd( m );
	INCR_DATA_PTR( 16*sizeof( GLdouble ) );
}

void __decodeLoadMatrixf( void  )
{
	GLfloat *m = DATA_POINTER( 0, GLfloat );

	__gltrack_LoadMatrixf( m );
	INCR_DATA_PTR( 16*sizeof( GLfloat ) );
}
